#!/usr/bin/perl
#
# XEN Server machine back, Jeremy Tirrell for Commercial Solutions INC 2009
# Modificado : Qualityinfo Solucoes em Informatica
#	       Marlo Luiz Binsfeld
#

$backupdir = "/mnt/backup/";								#Directory to backup to, this should be nfs share or something large.
$mailNotification = true;										#false for no notifcaiton
$mailScript = "/root/scripts/sendEmail";						#Brandon Zehm <caspian@dotconf.net> Change "server" to point to smtp server
$MailTo = "alertas\@qualityinfo.inf.br";								#mail to
$MailFrom = "alertas\@qualityinfo.inf.br";							#mail from
$host = "xenserver";									#Descriptive name
$Message = " \"XEN Backup Notification\n";					#header of message
$MailString = $mailScript . " -f " . $MailFrom . " -t " . $MailTo;		#mail string to control string passed to sendEmail
$TopicHeader = "[".$host ." XEN Server Backup Script] ";			#Subject.
$Topic = "";
$Avalspace = "`df -h |grep /mnt/backup|awk {'print $4'}`";
$DiskDevice = "/dev/sdd1";
$DirMount = "/mnt/backup/xenserver/";

@skip = ('0bd0b7f3-c21a-488f-92bc-e604f01d8189');				#add chunks of uuid to skip backing up of a specifc vm 
														#control domain (dom0) should be added to this list!!

$vmlist = `xe vm-list`;                                 						#Get the formatted list of guests
@lineList = split(/\n/,$vmlist);                       						#Split the list of guests into and array of lines
@uuid = ();                                             							#Array to store uuid's in

foreach $line(@lineList){										#for each line in the array
 if (substr($line,0,4) eq "uuid"){								#look for the word uuid at the beginning of the line
  push(@uuid, substr($line,23,36));							#if its there add the uuid to the array
 }
}

$tcurrent = `date`;											#get the current date

#verificado unidade de montagem
$Message .= " " ."\n";
$Message .= "Espaco Disponivel no Disco : $Avalspace" ."\n";
$Message .= " " ."\n";
if ( -d $DirMount ) {
                $Message .= "$DirMount ja existe." ."\n";
}       else    {
                $Message .= "$DirMount does not Exists, Mounting" ."\n";
		$status= `mount.ntfs-3g $DiskDevice $backupdir;`;
		print($status."\n");

}

print("Beginning backup of virtual machines at ". $tcurrent);
$Message .= " " ."\n";
$Message .= "Beginning backup of virtual machines at ". $tcurrent."\n";

foreach $guest(@uuid){										#for each guest listed in the uuid list
 $VMName = `xe vm-list uuid=$guest |grep name-label|cut -b 24-`;				# get name of vm, Roberto Cespa ! Thanks !
 $VMName =~ s/ /_/g; 
 $VMName =~ s/\n//g;
 $VMName =~ s/\r//g;
 if (grep $_ eq $guest, @skip){								#is guest on the skip list?
  print("Skipping backup of: ".$VMName ."\n");					#yes so just let it be known it is being skipped
  $Message .= "Skipping backup of: ".$VMName ."\n";
  $Message .= " " ."\n";
 } else {													#otherwise
  $tcurrent = `date`;     		                               					#get the current date
  print("Beginning backup of ".$VMName ." @ ". $tcurrent);
  $Message .= "Beginning backup of ".$VMName ." @ ". $tcurrent."\n";
  print("Taking a snapshot of: ".$VMName ."\n");					#Snapshot the VM
  $Message .= "Taking a snapshot of: ". $VMName ."\n";
  $snapshotUUID= `xe vm-snapshot vm=$guest new-name-label=backup_vm`;
  $snapshotUUID=~ s/\n//g;									#remove the carrier return/linefeed
  $snapshotUUID=~ s/\r//g;
  print("Snapshot: ".$VMName." created\n");

  $Message .= "Snapshot: ".$VMName." created\n";

  print("turning ".$VMName ." snapshot into a vm\n");		#Turn snapshot into a VM
  $Message .= "turning ".$VMName ." snapshot into a vm\n";
  $status= `xe template-param-set is-a-template=false ha-always-run=false uuid=$snapshotUUID`; # go roberto again!
  print($status."\n");
  $Message .= $status."\n";
  
  $fdate = `date +%d%m%y`;									#get the current date in a format we can write
  print("Exporting: ".$VMName."\n");						#export the snapshot
  $Message .= "Exporting: ".$VMName."\n";
  $exportstring = $backupdir.$VMName.".xva-".$fdate;
  $status= `xe vm-export vm=$snapshotUUID filename=$exportstring compress=true`;		
  print($status."\n");
  $Message .= $status."\n";
  
  print("Done, Removing snapshot: ".$VMName."\n");			#Done, remove the snapshot
  $Message .= "Done, Removing snapshot: ".$VMName."\n";
  $status= `xe vm-uninstall uuid=$snapshotUUID  force=true`;
  print($status."\n");
  $Message .= $status."\n";
  
  $tcurrent = `date`;                                   						#get the current date
  print("Completed backup of ".$VMName ." @ ". $tcurrent);
  $Message .= "Completed backup of ".$VMName ." @ ". $tcurrent."\n";
 }

}

$tfinished = `date`;
print("Backup completed at ".$tfinished);
$Message .= "Backup completed at ".$tfinished."\n\"";

if ($mailNotification){
 system($MailString . " -u " . $TopicHeader . $Topic ." -m " . $Message);
}
